#! /usr/bin/perl
# mljoin.cgi : edit opt-members.ph / by personal
# Copyright(C) 2001 by Yuh.N
# $Id: mljoin.cgi,v 1.1 2001/02/02 08:54:07 yuh Exp $
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
umask(0077);
use CGI;

$defaultdomain = 'wni.co.jp';

require "mllib.pl";
require "$ML_SETTING_ROOT/opt-members.ph";

if (-f "$ML_SETTING_ROOT/mlinfo.ph") {
    require "$ML_SETTING_ROOT/mlinfo.ph";
    $mlinfo_loaded = 1;
}

$PIDFILE = "$ML_SETTING_ROOT/mljoin.pid";

@mllist = ();
@m = MLlist();
foreach $ml (@m) {
    MLconfig_read($ml);
    if ($OPTIMIZED_DELIVERLIST == 1) {
	push(@mllist, $ml);
    }
}

$multi_column = 4;
$server_admin = 'yuh@wni.co.jp';

$q = new CGI;
print $q->header(-expires=>now, -title=>'MLjoin');
print $q->start_html(-bgcolor=>'#ffffff');
print "<form action=$ENV{'SCRIPT_NAME'} method=POST>\n";
print '<h1>᡼°</h1>',"\n";

if ($q->param('SUBMIT') eq 'Update') {
    @activeml = ();
    foreach $ml (@mllist) {
	if (defined ($q->param("chk.$ml"))) {
	    push(@activeml, $ml);
	}
    }

    if (defined($q->param('MailUser'))) {
	$mail = $q->param('MailUser');
	$list = $members{$mail};
	$tmpfile = "$ML_SETTING_ROOT/opt-members.$$";
	lock_on($PIDFILE);
	open(ORG, "$ML_SETTING_ROOT/opt-members.ph");
	open(NEW, ">$tmpfile");
	while (<ORG>) {
	    if (/^\'$mail/) {
		printf NEW "\'%s\' => [\'%s\',", $mail, $$list[0];
		foreach $ml (@activeml) {
		    print NEW "\'$ml\',";
		}
		print NEW "],\n";
	    }
	    else {
		print NEW;
	    }
	}
	close(NEW);
	close(ORG);
	system("mv -f $tmpfile $ML_SETTING_ROOT/opt-members.ph");
	lock_off($PIDFILE);

	$str = join(", ", @activeml);
	$tmpfile = "/tmp/mljoin.$$";
	open(M, ">$tmpfile");
	print M << "EOM";
᡼ƥफΤΤ餻Ǥ

$mail ν°᡼󥰥ꥹȤ
ʲΤ褦ѹˤʤޤǧ

$str

ѹϡhttp://172.16.20.100/cgi-bin/mljoin.cgi ǡ

EOM
	close(M);
	system("nkf $tmpfile | Mail $mail -s ML-announce");
	system("nkf $tmpfile | Mail $server_admin -s ML-announce") if (defined($server_admin));
	unlink($tmpfile);
    }
    print '򹹿ޤ<br>', "\n";
}
elsif (defined($q->param('MailUser'))) {
    $mail = $q->param('MailUser');

    if ($mail !~ /\@/) {
	$mail .= '@';
	$mail .= $defaultdomain;
    }

    print '᡼륢ɥ쥹 ', "\`", $mail, "\'";

    if (defined($members{$mail})) {
	print ' °MLɥ쥹<br>';

	if ($mlinfo_loaded == 1) {
	    print "<select name=mode onChange=\"this.form.submit();\">\n";
	    print "<option value=simple";
	    print " SELECTED" if ($q->param('mode') ne 'detail');
	    print '> άɽ (simplified)', "\n";
	    print "<option value=detail";
	    print " SELECTED" if ($q->param('mode') eq 'detail');
	    print '> ܺɽ (detailed)', "\n";
	    print "</select>";
	}
	if ($q->param('mode') eq 'detail') {
	    $detailed = 1;
	}
	else {
	    $detailed = 0;
	}

	%cache = ();
	$list = $members{$mail};
	foreach $ml (@$list) {
	    $cache{$ml} = 1;
	}

	$n = 0;
	print "<table>\n";
	foreach $ml (@mllist) {
	    print "<tr>\n" if ((($n % $multi_column) == 0) || ($detailed));
	    if (defined($cache{$ml})) {
		$ck = "CHECKED";
	    }
	    else {
		$ck = "";
	    }
	    print "<td>";
	    print "<input type=checkbox name=\"chk.$ml\" $ck> $ml <br>\n";
	    print "</td>";
	    if ($detailed) {
		print "<td>$mlinfotbl{$ml}</td>\n";
	    }
	    print "</tr>\n" if ((($n % $multi_column) == ($multi_column - 1)) || ($detailed));
	    $n++;
	}
	print "</table>\n";
	print '嵭Ƥ򹹿ޤ';
	print "<input type=hidden name=MailUser value=\"$mail\">\n";
	print "<input type=submit name=SUBMIT value=Update>\n";
    }
    else {
	print ' ¸ߤޤ<br>';
	print '᡼륢ɥ쥹ϤƲ',"\n";
	print "<input type=text name=MailUser>\n";
	print "<input type=submit name=SUBMIT value=Accept>\n";
    }
}
else {
    print '᡼륢ɥ쥹ϤƲ',"\n";
    print "<input type=text name=MailUser>\n";
    print "<input type=submit name=SUBMIT value=Accept>\n";
}



print "</form>\n";
print $q->end_html();
